---
# Deploy debian package to apt repository
.deploy:package:
  image: $SAH_CI_IMAGE
  tags: [docker]
  stage: deploy
  interruptible: true
  rules:
    - if: '$GITLAB_INTERNAL && $CI_COMMIT_TAG && $PC_DEPLOY_PACKAGE == "on"'
      exists:
        - packages/package_debian/makefile
        - packages/package_debian/Makefile
        - ci/packaging/deb/Makefile
  retry:
    max: 2
    when:
      - runner_system_failure
      - api_failure
      - scheduler_failure
  variables:
    ARCH: amd64
  script:
    - git fetch --tags
    - |
      if  [[ -f ci/packaging/deb/Makefile ]]; then
        PACKAGE=$(find . -name "*.deb") && echo $PACKAGE;
      else
        PACKAGE=$(find . -name "$BUILD_TARGET*_$ARCH.deb") && echo $PACKAGE;
      fi
      MD5SUM=($(md5sum "$PACKAGE"));
      SHA1SUM=($(sha1sum "$PACKAGE"));
      curl -u "$APT_USER:$APT_PASS" -i -H "X-Checksum-MD5:$MD5SUM" -H "X-Checksum-Sha1:$SHA1SUM" -XPUT "http://$APT_HOST/artifactory/sah-debian/pool/packages/main/binary-amd64/$CI_PROJECT_PATH/$(basename $PACKAGE);deb.distribution=sah;deb.component=main;deb.architecture=$ARCH" -T "$PACKAGE";
      curl -f -u "$APT_USER_EXTERNAL:$APT_PASS_EXTERNAL" -H "Content-Type: multipart/form-data" --data-binary "@$PACKAGE" "https://nexus.rd.softathome.com/repository/apt/";

.pages:
  image: $SAH_CI_IMAGE
  tags: [docker]
  stage: deploy
  interruptible: true
  rules:
    - if: '$PC_PAGES == "off"'
      when: never
    - if: '$GITLAB_INTERNAL == null && $CI_COMMIT_TAG'
  retry:
    max: 2
    when:
      - runner_system_failure
      - api_failure
      - scheduler_failure
  script:
  # Coverage report
  - mkdir -p $CI_PROJECT_DIR/gitlab-pages/coverage/
  - cp -R $CI_PROJECT_DIR/output/*/coverage/report/* $CI_PROJECT_DIR/gitlab-pages/coverage || true
  # Keep deprecated coverage report path alive
  - mkdir -p $CI_PROJECT_DIR/gitlab-pages/coverage/x86_64-linux-gnu
  - cp -R $CI_PROJECT_DIR/output/*/coverage/report/* $CI_PROJECT_DIR/gitlab-pages/coverage/x86_64-linux-gnu || true
  # Doxygen documentation
  - mkdir -p $CI_PROJECT_DIR/gitlab-pages/doxygen
  - mv $CI_PROJECT_DIR/$BLD_OUTPUT_DIR/doc/$DOC_HTML_DIR/* $CI_PROJECT_DIR/gitlab-pages/doxygen || true
  # Datamodel documentation
  - mkdir -p $CI_PROJECT_DIR/gitlab-pages/datamodel
  - mv $CI_PROJECT_DIR/$BLD_OUTPUT_DIR/html/* $CI_PROJECT_DIR/gitlab-pages/datamodel || true
  # Move everything to gitlab pages
  - mv $CI_PROJECT_DIR/gitlab-pages/ public/ || true
  # Gitlab fails if zero files are in the public folder
  - touch public/index.html
  artifacts:
    paths:
    - public
